divert(-1)
# foreach(x, (item_1, item_2, ..., item_n), stmt)
define(`foreach', `pushdef(`$1', `')_foreach(`$1', `$2', `$3')popdef(`$1')')
define(`_arg1', `$1')
define(`_foreach', 
	`ifelse(`$2', `()', ,
		`define(`$1', _arg1$2)$3`'_foreach(`$1', (shift$2), `$3')')')')
dnl # traceon(`define', `foreach', `_foreach', `ifelse')
dnl foreach(`x', `(foo, bar, foobar)', `Word was: x
dnl ')
dnl # Something more complex, from Pierre Gaumond <gaumondp@ere.umontreal.ca>.
dnl define(`case', `  $1)
dnl     $2=" -$1";;
dnl ')dnl
dnl define(`_cat', `$1$2')dnl
dnl `case' "$1" in
dnl foreach(`x', ((a, vara), (b, varb), (c, varc)), `_cat(`case', x)')dnl
dnl esac
divert dnl
